Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureTypeOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureTypeOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/FetchFeatureTypeOperation.java	(revision 44198)
@@ -11,6 +11,8 @@
 import org.apache.commons.collections.CollectionUtils;
 import org.apache.commons.lang3.StringUtils;
 import org.cresques.cts.IProjection;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Variable;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
@@ -19,6 +21,8 @@
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_FEATURE_TYPE;
+import static org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase.PROP_TABLE;
 import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.fmap.geom.GeometryLocator;
 import org.gvsig.fmap.geom.type.GeometryType;
@@ -256,6 +260,7 @@
             String table
         ) throws SQLException {
         JDBCSQLBuilderBase sqlbuilder = this.createSQLBuilder();
+        ExpressionBuilder expbuilder = sqlbuilder.expression();
 
         sqlbuilder.select().column().name("COLUMN_NAME");
         sqlbuilder.select().column().name("CONSTRAINT_TYPE");
@@ -268,31 +273,31 @@
                 + "c.constraint_name = t_cons.constraint_name "
         );
         sqlbuilder.select().where().set(
-                sqlbuilder.like(
-                        sqlbuilder.custom("c.TABLE_NAME"), 
-                        sqlbuilder.constant(table)
+                expbuilder.like(
+                        expbuilder.custom("c.TABLE_NAME"), 
+                        expbuilder.constant(table)
                 )
         );
         if (schema != null) {
             sqlbuilder.select().where().and(
-                    sqlbuilder.like(
-                            sqlbuilder.custom("c.TABLE_SCHEMA"),
-                            sqlbuilder.constant(schema)
+                    expbuilder.like(
+                            expbuilder.custom("c.TABLE_SCHEMA"),
+                            expbuilder.constant(schema)
                     )
             );
         }
         if (catalog != null) {
             sqlbuilder.select().where().and(
-                    sqlbuilder.like(
-                            sqlbuilder.custom("c.CONSTRAINT_CATALOG"),
-                            sqlbuilder.constant(catalog)
+                    expbuilder.like(
+                            expbuilder.custom("c.CONSTRAINT_CATALOG"),
+                            expbuilder.constant(catalog)
                     )
             );
         }
         sqlbuilder.select().where().and(
-                sqlbuilder.eq(
-                        sqlbuilder.column("CONSTRAINT_TYPE"),
-                        sqlbuilder.constant("PRIMARY KEY")
+                expbuilder.eq(
+                        expbuilder.column("CONSTRAINT_TYPE"),
+                        expbuilder.constant("PRIMARY KEY")
                 )
         );
         return sqlbuilder.toString();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AppendOperation.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AppendOperation.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/operations/AppendOperation.java	(revision 44198)
@@ -4,7 +4,9 @@
 import java.sql.Connection;
 import java.sql.PreparedStatement;
 import java.sql.SQLException;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.fmap.dal.DataTypes;
+import org.gvsig.fmap.dal.SQLBuilder;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureType;
@@ -13,7 +15,6 @@
 import org.gvsig.fmap.dal.store.jdbc.exception.JDBCPreparingSQLException;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCHelper;
 import org.gvsig.fmap.dal.store.jdbc2.JDBCUtils;
-import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory;
 import org.gvsig.fmap.dal.store.jdbc2.OperationsFactory.TableReference;
 import org.gvsig.fmap.dal.store.jdbc2.spi.JDBCSQLBuilderBase;
 import org.gvsig.tools.dispose.Disposable;
@@ -28,6 +29,8 @@
     protected final FeatureType type;
     
     protected JDBCSQLBuilderBase sqlbuilder = null;
+    protected ExpressionBuilder expbuilder;
+
     protected PreparedStatement preparedStatement;
     protected String sql;
     
@@ -50,6 +53,7 @@
             this.connection = this.helper.getConnectionWritable();
             
             this.sqlbuilder = this.helper.createSQLBuilder();
+            this.expbuilder = this.sqlbuilder.expression();
 
             this.sqlbuilder.insert().table()
                     .database(this.table.getDatabase())
@@ -62,13 +66,13 @@
                 }
                 if (attr.getType() == DataTypes.GEOMETRY) {
                     this.sqlbuilder.insert().column().name(attr.getName()).with_value( 
-                        sqlbuilder.parameter(attr.getName()).as_geometry_variable().srs( 
-                                sqlbuilder.parameter().value(attr.getSRS()) 
+                        expbuilder.parameter(attr.getName()).as_geometry_variable().srs( 
+                                expbuilder.parameter().value(attr.getSRS()) 
                         ) 
                     );
                 } else {
                     this.sqlbuilder.insert().column().name(attr.getName()).with_value(
-                        sqlbuilder.parameter(attr.getName()).as_variable()
+                        expbuilder.parameter(attr.getName()).as_variable()
                     );
                 }
             }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCSQLBuilderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCSQLBuilderBase.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCSQLBuilderBase.java	(revision 44198)
@@ -6,8 +6,11 @@
 import java.util.ArrayList;
 import java.util.List;
 import org.cresques.cts.IProjection;
+import org.gvsig.expressionevaluator.ExpressionBuilder.GeometrySupportType;
+import org.gvsig.expressionevaluator.ExpressionBuilder.Parameter;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureReference;
+import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.spi.SQLBuilderBase;
 import org.gvsig.fmap.dal.feature.spi.FeatureProvider;
@@ -25,8 +28,12 @@
 import org.gvsig.fmap.geom.type.GeometryType;
 import org.gvsig.tools.dispose.Disposable;
 
+@SuppressWarnings("UseSpecificCatch")
 public class JDBCSQLBuilderBase extends SQLBuilderBase {
 
+    public static final String PROP_FEATURE_TYPE = "FeatureType";
+    public static final String PROP_TABLE = "Table";
+    
     private GeometryManager geometryManager = null;
     protected final JDBCHelper helper;
     
@@ -47,7 +54,7 @@
     }
     
     @Override
-    public Object getSRSId(IProjection projection) {
+    public Object srs_id(IProjection projection) {
         Connection conn = null;
         try {
             conn = this.helper.getConnection();
@@ -71,13 +78,13 @@
     public void setParameters(PreparedStatement st) {
         try {
             int columnIndex = 1;
-            for (Parameter parameter : this.getParameters()) {
-                st.setObject(columnIndex++, parameter.getValue());
+            for (Parameter parameter : this.parameters()) {
+                st.setObject(columnIndex++, parameter.value());
             }
         } catch (Exception ex) {
             String p = "unknow";
             try {
-                p =  this.getParameters().toString();
+                p =  this.parameters().toString();
             } catch (Exception ex2) {
                 // Do nothing
             }
@@ -90,12 +97,12 @@
             FeatureType type = feature.getType();
             List<Object> values = new ArrayList<>();
             Object value;
-            for (Parameter parameter : this.getParameters()) {
+            for (Parameter parameter : this.parameters()) {
                 if (parameter.is_constant()) {
-                    value = parameter.getValue();
+                    value = parameter.value();
                     values.add(value);
                 } else {
-                    String name = parameter.getName();
+                    String name = parameter.name();
                     value = feature.get(name);
                     FeatureAttributeDescriptor attrDesc = type.getAttributeDescriptor(name);
                     if( attrDesc.getType()==DataTypes.GEOMETRY ) {
@@ -173,11 +180,11 @@
         try {
             
             List<Object> values = new ArrayList<>();
-            for (Parameter parameter : this.getParameters()) {
+            for (Parameter parameter : this.parameters()) {
                 if (parameter.is_constant()) {
-                    values.add(parameter.getValue());
+                    values.add(parameter.value());
                 } else {
-                    String name = parameter.getName();
+                    String name = parameter.name();
                     values.add(((FeatureReferenceProviderServices)reference).getKeyValue(name));
                 }
             }
@@ -205,7 +212,7 @@
                 }
             };
         }
-        if( logger.isDebugEnabled() ) {
+        if( LOGGER.isDebugEnabled() ) {
             StringBuilder debug = new StringBuilder();
             debug.append("st.set(");
             try {
@@ -219,7 +226,7 @@
                                 debug.append("/*");
                                 debug.append(columnIndex);
                                 debug.append("*/ ");
-                                debug.append(string((String) value));
+                                debug.append(as_string(value));
                                 debug.append(", ");
                                 break;
                             case NATIVE:
@@ -228,7 +235,7 @@
                                 debug.append("/*");
                                 debug.append(columnIndex);
                                 debug.append("*/ ");
-                                debug.append(bytearray(bytes));
+                                debug.append(as_string(bytes));
                                 debug.append(", ");
                                 break;
                             case EWKB:
@@ -236,7 +243,7 @@
                                 debug.append("/*");
                                 debug.append(columnIndex);
                                 debug.append("*/ ");
-                                debug.append(bytearray(bytes));
+                                debug.append(as_string(bytes));
                                 debug.append(", ");
                                 break;
                         }
@@ -245,9 +252,9 @@
                         debug.append(columnIndex);
                         debug.append("*/ ");
                         if( value instanceof String ) {
-                            debug.append(string((String) value));
+                            debug.append(as_string(value));
                         } else if( value instanceof Boolean ) {
-                            debug.append( ((Boolean)value)? config.getString(Config.constant_true):config.getString(Config.constant_false) );
+                            debug.append( ((Boolean)value)? constant_true:constant_false );
                         } else {
                             debug.append(value);
                         }
@@ -256,7 +263,7 @@
                     columnIndex++;
                 }
                 debug.append(")");
-                logger.debug(debug.toString());
+                LOGGER.debug(debug.toString());
             } catch(Exception ex) {
             }        
         }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCStoreProviderBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCStoreProviderBase.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCStoreProviderBase.java	(revision 44198)
@@ -219,13 +219,7 @@
         }
     }
 
-    
     @Override
-    public JDBCSQLBuilderBase createExpression() {
-        return this.getHelper().createSQLBuilder();
-    }
-
-    @Override
     public JDBCStoreParameters getParameters() {
         return (JDBCStoreParameters) super.getParameters();
     }  
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc2/spi/JDBCHelperBase.java	(revision 44198)
@@ -15,11 +15,13 @@
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
 import org.gvsig.expressionevaluator.Function;
+import org.gvsig.expressionevaluator.SymbolTable;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.exception.InitializeException;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureQueryOrder;
+import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.dal.feature.FeatureType;
 
 import org.gvsig.fmap.dal.feature.spi.FeatureProvider;
@@ -159,12 +161,13 @@
     }
 
     @Override
-    public boolean supportFilter(Evaluator filter) {
+    public boolean supportFilter(final FeatureType type, Evaluator filter) {
         // No podemos filtrar cuando:
         // - Hay una subquery especificada en los parametros 
         // - Si hay un filtro y el getSQL devuelbe null.
         // - Si se esta usando alguna funcion no-sql en el getSQL
         // - Si se estan usando funciones OGC y no soportamos funciones espaciales
+        // - Si se esta usando algun campo calculado en la expresion de filtro.
         // 
         // Un proveedor especifico podria sobreescribir el metodo,
         // para hilar mas fino al comprobar si soporta el filtro o no.
@@ -189,32 +192,50 @@
         // Ahora vamos a comprobar que las funciones que se usan son 
         // compatibles sql, y que no se usan funciones OGC si el 
         // proveedor dice que no soporta funciones espaciales.
+        // Tambien comprobaremos que el filtro no usa ningun campo calculado.
         final MutableBoolean isCompatible = new MutableBoolean(true);
         final boolean supportSpatialFunctions = this.hasSpatialFunctions();
         ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
         Code code = manager.compile(sql);
+        SymbolTable symbolTable = manager.createSymbolTable();
+        code.link(symbolTable);
         try {
             code.accept(new Visitor() {
                 @Override
                 public void visit(Object code_obj) throws VisitCanceledException, BaseException {
                     Code code = (Code) code_obj;
-                    if ( code.code()==Code.CALLER ) {
-                        Code.Caller caller = (Code.Caller) code;
-                        Function function = caller.function();
-                        if( function==null ) {
-                            isCompatible.setValue(false);
-                            throw new VisitCanceledException();
-                        }
-                        if( !function.isSQLCompatible() ) {
-                            isCompatible.setValue(false);
-                            throw new VisitCanceledException();
-                        }
-                        if( !supportSpatialFunctions ) {
-                            if( StringUtils.equalsIgnoreCase(function.group(),Function.GROUP_OGC) ) {
+                    switch(code.code()) {
+                        case Code.CALLER:
+                            Code.Caller caller = (Code.Caller) code;
+                            Function function = caller.function();
+                            if( function==null ) {
                                 isCompatible.setValue(false);
                                 throw new VisitCanceledException();
                             }
-                        }
+                            if( !function.isSQLCompatible() ) {
+                                isCompatible.setValue(false);
+                                throw new VisitCanceledException();
+                            }
+                            if( !supportSpatialFunctions ) {
+                                if( StringUtils.equalsIgnoreCase(function.group(),Function.GROUP_OGC) ) {
+                                    isCompatible.setValue(false);
+                                    throw new VisitCanceledException();
+                                }
+                            }
+                            break;
+                            
+                        case Code.IDENTIFIER:
+                            Code.Identifier identifier = (Code.Identifier) code;
+                            if( type!=null ) {
+                                FeatureAttributeDescriptor attrdesc = type.getAttributeDescriptor(identifier.name());
+                                if( attrdesc!=null ) {
+                                    if( attrdesc.isComputed() ) {
+                                        isCompatible.setValue(false);
+                                        throw new VisitCanceledException();
+                                    }
+                                }
+                            }
+                            break;
                     }
                 }
             });
@@ -229,7 +250,7 @@
     }
     
     @Override
-    public boolean supportOrder(FeatureQueryOrder order) {
+    public boolean supportOrder(FeatureType type, FeatureQueryOrder order) {
         if (this.useSubquery()) {
             return false;
         }
@@ -238,7 +259,7 @@
         }
         for( FeatureQueryOrder.FeatureQueryOrderMember member : order.members() ) {
             if (member.hasEvaluator()) {
-                if( !this.supportFilter(member.getEvaluator()) ) {
+                if( !this.supportFilter(type, member.getEvaluator()) ) {
                     return false;
                 }
             }            
@@ -324,6 +345,7 @@
        }
     }
 
+    @Override
     public void closeConnectionQuietly(Connection connection) {
         if( connection != null ) {
             LOGGER.debug("Clossing connection quietly "+connection.hashCode());
@@ -509,5 +531,10 @@
                parameters.getSchema()+ ":" + 
                parameters.tableID();
     }
+
+    @Override
+    public boolean isThreadSafe() {
+        return true;
+    }
     
 }
